# Class StandardEmitterMBean

java.lang.Object
javax.management.StandardMBean
javax.management.StandardEmitterMBean

All Implemented Interfaces:
  `DynamicMBean, MBeanRegistration, NotificationBroadcaster, NotificationEmitter`

public class StandardEmitterMBean extends StandardMBean implements NotificationEmitter

An MBean whose management interface is determined by reflection on a Java interface, and that emits notifications.

The following example shows how to use the public constructor `StandardEmitterMBean(implementation, mbeanInterface, emitter)` to create an MBean emitting notifications with any implementation class name Impl, with a management interface defined (as for current Standard MBeans) by any interface Intf, and with any implementation of the interface `NotificationEmitter`. The example uses the class `NotificationBroadcasterSupport` as an implementation of the interface `NotificationEmitter`.

        MBeanServer mbs;
        ...
        final String[] types = new String[] {"sun.disc.space","sun.disc.alarm"};
        final MBeanNotificationInfo info = new MBeanNotificationInfo(
                                             types,
                                             Notification.class.getName(),
                                             "Notification about disc info.");
        final NotificationEmitter emitter =
                       new NotificationBroadcasterSupport(info);

        final Intf impl = new Impl(...);
        final Object mbean = new StandardEmitterMBean(
                                        impl, Intf.class, emitter);
        mbs.registerMBean(mbean, objectName);

Since:
  1.6
See Also:
  - `StandardMBean`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `StandardEmitterMBean(Class<?> mbeanInterface, boolean isMXBean, NotificationEmitter emitter)`
  Make an MBean whose management interface is specified by `mbeanInterface`, and where notifications are handled by the given `NotificationEmitter`.
  `protected`
  `StandardEmitterMBean(Class<?> mbeanInterface, NotificationEmitter emitter)`
  Make an MBean whose management interface is specified by `mbeanInterface`, and where notifications are handled by the given `NotificationEmitter`.
  `<T>`
  `StandardEmitterMBean(T implementation, Class<T> mbeanInterface, boolean isMXBean, NotificationEmitter emitter)`
  Make an MBean whose management interface is specified by `mbeanInterface`, with the given implementation and where notifications are handled by the given `NotificationEmitter`.
  `<T>`
  `StandardEmitterMBean(T implementation, Class<T> mbeanInterface, NotificationEmitter emitter)`
  Make an MBean whose management interface is specified by `mbeanInterface`, with the given implementation and where notifications are handled by the given `NotificationEmitter`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addNotificationListener(NotificationListener listener, NotificationFilter filter, Object handback)`
  Adds a listener to this MBean.
  `MBeanNotificationInfo[]`
  `getNotificationInfo()`
  Returns an array indicating, for each notification this MBean may send, the name of the Java class of the notification and the notification type.
  `void`
  `removeNotificationListener(NotificationListener listener)`
  Removes a listener from this MBean.
  `void`
  `removeNotificationListener(NotificationListener listener, NotificationFilter filter, Object handback)`
  Removes a listener from this MBean.
  `void`
  `sendNotification(Notification n)`
  Sends a notification.

  ### Methods declared in class StandardMBean

  `cacheMBeanInfo, getAttribute, getAttributes, getCachedMBeanInfo, getClassName, getConstructors, getDescription, getDescription, getDescription, getDescription, getDescription, getDescription, getDescription, getImpact, getImplementation, getImplementationClass, getMBeanInfo, getMBeanInterface, getParameterName, getParameterName, invoke, postDeregister, postRegister, preDeregister, preRegister, setAttribute, setAttributes, setImplementation`
  Modifier and Type
  Method
  Description
  `protected void`
  `cacheMBeanInfo(MBeanInfo info)`
  Customization hook: cache the MBeanInfo built for this object.
  `Object`
  `getAttribute(String attribute)`
  Obtain the value of a specific attribute of the Dynamic MBean.
  `AttributeList`
  `getAttributes(String[] attributes)`
  Get the values of several attributes of the Dynamic MBean.
  `protected MBeanInfo`
  `getCachedMBeanInfo()`
  Customization hook: Return the MBeanInfo cached for this object.
  `protected String`
  `getClassName(MBeanInfo info)`
  Customization hook: Get the className that will be used in the MBeanInfo returned by this MBean.
  `protected MBeanConstructorInfo[]`
  `getConstructors(MBeanConstructorInfo[] ctors, Object impl)`
  Customization hook: Get the MBeanConstructorInfo[] that will be used in the MBeanInfo returned by this MBean.
  `protected String`
  `getDescription(MBeanAttributeInfo info)`
  Customization hook: Get the description that will be used in the MBeanAttributeInfo returned by this MBean.
  `protected String`
  `getDescription(MBeanConstructorInfo info)`
  Customization hook: Get the description that will be used in the MBeanConstructorInfo returned by this MBean.
  `protected String`
  `getDescription(MBeanConstructorInfo ctor, MBeanParameterInfo param, int sequence)`
  Customization hook: Get the description that will be used for the sequence MBeanParameterInfo of the MBeanConstructorInfo returned by this MBean.
  `protected String`
  `getDescription(MBeanFeatureInfo info)`
  Customization hook: Get the description that will be used in the MBeanFeatureInfo returned by this MBean.
  `protected String`
  `getDescription(MBeanInfo info)`
  Customization hook: Get the description that will be used in the MBeanInfo returned by this MBean.
  `protected String`
  `getDescription(MBeanOperationInfo info)`
  Customization hook: Get the description that will be used in the MBeanOperationInfo returned by this MBean.
  `protected String`
  `getDescription(MBeanOperationInfo op, MBeanParameterInfo param, int sequence)`
  Customization hook: Get the description that will be used for the sequence MBeanParameterInfo of the MBeanOperationInfo returned by this MBean.
  `protected int`
  `getImpact(MBeanOperationInfo info)`
  Customization hook: Get the impact flag of the operation that will be used in the MBeanOperationInfo returned by this MBean.
  `Object`
  `getImplementation()`
  Get the implementation of this Standard MBean (or MXBean).
  `Class<?>`
  `getImplementationClass()`
  Get the class of the implementation of this Standard MBean (or MXBean).
  `MBeanInfo`
  `getMBeanInfo()`
  Get the `MBeanInfo` for this MBean.
  `final Class<?>`
  `getMBeanInterface()`
  Get the Management Interface of this Standard MBean (or MXBean).
  `protected String`
  `getParameterName(MBeanConstructorInfo ctor, MBeanParameterInfo param, int sequence)`
  Customization hook: Get the name that will be used for the sequence MBeanParameterInfo of the MBeanConstructorInfo returned by this MBean.
  `protected String`
  `getParameterName(MBeanOperationInfo op, MBeanParameterInfo param, int sequence)`
  Customization hook: Get the name that will be used for the sequence MBeanParameterInfo of the MBeanOperationInfo returned by this MBean.
  `Object`
  `invoke(String actionName, Object[] params, String[] signature)`
  Allows an action to be invoked on the Dynamic MBean.
  `void`
  `postDeregister()`
  Allows the MBean to perform any operations needed after having been unregistered in the MBean server.
  `void`
  `postRegister(Boolean registrationDone)`
  Allows the MBean to perform any operations needed after having been registered in the MBean server or after the registration has failed.
  `void`
  `preDeregister()`
  Allows the MBean to perform any operations it needs before being unregistered by the MBean server.
  `ObjectName`
  `preRegister(MBeanServer server, ObjectName name)`
  Allows the MBean to perform any operations it needs before being registered in the MBean server.
  `void`
  `setAttribute(Attribute attribute)`
  Set the value of a specific attribute of the Dynamic MBean.
  `AttributeList`
  `setAttributes(AttributeList attributes)`
  Sets the values of several attributes of the Dynamic MBean.
  `void`
  `setImplementation(Object implementation)`
  Replace the implementation object wrapped in this object.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### StandardEmitterMBean

    public <T> StandardEmitterMBean(T implementation, Class<T> mbeanInterface, NotificationEmitter emitter)

    Make an MBean whose management interface is specified by `mbeanInterface`, with the given implementation and where notifications are handled by the given `NotificationEmitter`. The resultant MBean implements the `NotificationEmitter` interface by forwarding its methods to `emitter`. It is legal and useful for `implementation` and `emitter` to be the same object.

    If `emitter` is an instance of `NotificationBroadcasterSupport` then the MBean's `sendNotification` method will call `emitter.``sendNotification`.

    The array returned by `getNotificationInfo()` on the new MBean is a copy of the array returned by `emitter.``getNotificationInfo()` at the time of construction. If the array returned by `emitter.getNotificationInfo()` later changes, that will have no effect on this object's `getNotificationInfo()`.

    Type Parameters:
      `T` - the implementation type of the MBean
    Parameters:
      `implementation` - the implementation of the MBean interface.
      `mbeanInterface` - a Standard MBean interface.
      `emitter` - the object that will handle notifications.
    Throws:
      `IllegalArgumentException` - if the `mbeanInterface` does not follow JMX design patterns for Management Interfaces, or if the given `implementation` does not implement the specified interface, or if `emitter` is null.

  - ### StandardEmitterMBean

    public <T> StandardEmitterMBean(T implementation, Class<T> mbeanInterface, boolean isMXBean, NotificationEmitter emitter)

    Make an MBean whose management interface is specified by `mbeanInterface`, with the given implementation and where notifications are handled by the given `NotificationEmitter`. This constructor can be used to make either Standard MBeans or MXBeans. The resultant MBean implements the `NotificationEmitter` interface by forwarding its methods to `emitter`. It is legal and useful for `implementation` and `emitter` to be the same object.

    If `emitter` is an instance of `NotificationBroadcasterSupport` then the MBean's `sendNotification` method will call `emitter.``sendNotification`.

    The array returned by `getNotificationInfo()` on the new MBean is a copy of the array returned by `emitter.``getNotificationInfo()` at the time of construction. If the array returned by `emitter.getNotificationInfo()` later changes, that will have no effect on this object's `getNotificationInfo()`.

    Type Parameters:
      `T` - the implementation type of the MBean
    Parameters:
      `implementation` - the implementation of the MBean interface.
      `mbeanInterface` - a Standard MBean interface.
      `isMXBean` - If true, the `mbeanInterface` parameter names an MXBean interface and the resultant MBean is an MXBean.
      `emitter` - the object that will handle notifications.
    Throws:
      `IllegalArgumentException` - if the `mbeanInterface` does not follow JMX design patterns for Management Interfaces, or if the given `implementation` does not implement the specified interface, or if `emitter` is null.

  - ### StandardEmitterMBean

    protected StandardEmitterMBean(Class<?> mbeanInterface, NotificationEmitter emitter)

    Make an MBean whose management interface is specified by `mbeanInterface`, and where notifications are handled by the given `NotificationEmitter`. The resultant MBean implements the `NotificationEmitter` interface by forwarding its methods to `emitter`.

    If `emitter` is an instance of `NotificationBroadcasterSupport` then the MBean's `sendNotification` method will call `emitter.``sendNotification`.

    The array returned by `getNotificationInfo()` on the new MBean is a copy of the array returned by `emitter.``getNotificationInfo()` at the time of construction. If the array returned by `emitter.getNotificationInfo()` later changes, that will have no effect on this object's `getNotificationInfo()`.

    This constructor must be called from a subclass that implements the given `mbeanInterface`.

    Parameters:
      `mbeanInterface` - a StandardMBean interface.
      `emitter` - the object that will handle notifications.
    Throws:
      `IllegalArgumentException` - if the `mbeanInterface` does not follow JMX design patterns for Management Interfaces, or if `this` does not implement the specified interface, or if `emitter` is null.

  - ### StandardEmitterMBean

    protected StandardEmitterMBean(Class<?> mbeanInterface, boolean isMXBean, NotificationEmitter emitter)

    Make an MBean whose management interface is specified by `mbeanInterface`, and where notifications are handled by the given `NotificationEmitter`. This constructor can be used to make either Standard MBeans or MXBeans. The resultant MBean implements the `NotificationEmitter` interface by forwarding its methods to `emitter`.

    If `emitter` is an instance of `NotificationBroadcasterSupport` then the MBean's `sendNotification` method will call `emitter.``sendNotification`.

    The array returned by `getNotificationInfo()` on the new MBean is a copy of the array returned by `emitter.``getNotificationInfo()` at the time of construction. If the array returned by `emitter.getNotificationInfo()` later changes, that will have no effect on this object's `getNotificationInfo()`.

    This constructor must be called from a subclass that implements the given `mbeanInterface`.

    Parameters:
      `mbeanInterface` - a StandardMBean interface.
      `isMXBean` - If true, the `mbeanInterface` parameter names an MXBean interface and the resultant MBean is an MXBean.
      `emitter` - the object that will handle notifications.
    Throws:
      `IllegalArgumentException` - if the `mbeanInterface` does not follow JMX design patterns for Management Interfaces, or if `this` does not implement the specified interface, or if `emitter` is null.

- ## Method Details

  - ### removeNotificationListener

    public void removeNotificationListener(NotificationListener listener) throws ListenerNotFoundException
    Description copied from interface: `NotificationBroadcaster`
    Removes a listener from this MBean. If the listener has been registered with different handback objects or notification filters, all entries corresponding to the listener will be removed.
    Specified by:
      `removeNotificationListener` in interface `NotificationBroadcaster`
    Parameters:
      `listener` - A listener that was previously added to this MBean.
    Throws:
      `ListenerNotFoundException` - The listener is not registered with the MBean.
    See Also:
      - `NotificationBroadcaster.addNotificationListener(NotificationListener, NotificationFilter, Object)`
      - `NotificationEmitter.removeNotificationListener(NotificationListener, NotificationFilter, Object)`

  - ### removeNotificationListener

    public void removeNotificationListener(NotificationListener listener, NotificationFilter filter, Object handback) throws ListenerNotFoundException
    Description copied from interface: `NotificationEmitter`

    Removes a listener from this MBean. The MBean must have a listener that exactly matches the given `listener`, `filter`, and `handback` parameters. If there is more than one such listener, only one is removed.

    The `filter` and `handback` parameters may be null if and only if they are null in a listener to be removed.

    Specified by:
      `removeNotificationListener` in interface `NotificationEmitter`
    Parameters:
      `listener` - A listener that was previously added to this MBean.
      `filter` - The filter that was specified when the listener was added.
      `handback` - The handback that was specified when the listener was added.
    Throws:
      `ListenerNotFoundException` - The listener is not registered with the MBean, or it is not registered with the given filter and handback.

  - ### addNotificationListener

    public void addNotificationListener(NotificationListener listener, NotificationFilter filter, Object handback)
    Description copied from interface: `NotificationBroadcaster`
    Adds a listener to this MBean.
    Specified by:
      `addNotificationListener` in interface `NotificationBroadcaster`
    Parameters:
      `listener` - The listener object which will handle the notifications emitted by the broadcaster.
      `filter` - The filter object. If filter is null, no filtering will be performed before handling notifications.
      `handback` - An opaque object to be sent back to the listener when a notification is emitted. This object cannot be used by the Notification broadcaster object. It should be resent unchanged with the notification to the listener.
    See Also:
      - `NotificationBroadcaster.removeNotificationListener(NotificationListener)`

  - ### getNotificationInfo

    public MBeanNotificationInfo[] getNotificationInfo()
    Description copied from interface: `NotificationBroadcaster`

    Returns an array indicating, for each notification this MBean may send, the name of the Java class of the notification and the notification type.

    It is not illegal for the MBean to send notifications not described in this array. However, some clients of the MBean server may depend on the array being complete for their correct functioning.

    Specified by:
      `getNotificationInfo` in interface `NotificationBroadcaster`
    Returns:
      the array of possible notifications.

  - ### sendNotification

    public void sendNotification(Notification n)

    Sends a notification.

    If the `emitter` parameter to the constructor was an instance of `NotificationBroadcasterSupport` then this method will call `emitter.``sendNotification`.

    Parameters:
      `n` - the notification to send.
    Throws:
      `ClassCastException` - if the `emitter` parameter to the constructor was not a `NotificationBroadcasterSupport`.